(    Title:  Tests for dstester
      File:  dstester-test.fs
  Log file:  dstester.log
    Author:  David N. Williams
   License:  Public Domain
   Version:  1.4.0
   Revised:  February 11, 2018
)
 
\ Ensure that fp is enabled for pfe.
s" FLOATING-EXT" environment? [IF] ( flag) drop [ELSE]
cr .( FLOATING POINT NOT AVAILABLE) cr ABORT [THEN]

s" ttester-xf.fs"     INCLUDED
s" tester-display.fs" INCLUDED  \ uses VERBOSE
s" xtester-errors.fs" INCLUDED
s" ftester-errors.fs" INCLUDED
true VERBOSE !

\ Set the following to true to load DSTRINGS-EXT when pfe is the host.
false VALUE USE-DSTRINGS-EXT

PFE-HOST 0= [IF]
  false to USE-DSTRINGS-EXT
[THEN]

USE-DSTRINGS-EXT
[IF]   LOADM dstrings            \ pfe
[ELSE] s" dstrings.fs" INCLUDED  \ ANS Forth
[THEN]

\ debugging
[UNDEFINED] \\ [IF]
: \\  ( -- )  -1 parse 2drop BEGIN refill 0= UNTIL ;
[THEN]

\ these will be reduced for later overflow triggers
 2 VALUE MAX-DST-INITIALS 
16 VALUE MAX-DST-RESULTS
 3 VALUE MAX-DSFT-RESULTS

#13 BASE !                \ test dstester BASE invariance
s" dstester.fs" INCLUDED
T{ BASE @ -> #13 }T
decimal

\ debugging
: .depths  ( -- )
  ." $depth: " $depth .  ."    $frame depth: " $frame-depth .
  ."   data depth: " depth .   ."   fp depth: " fdepth .   cr ;


VARIABLE #errors    0 #errors !
: ?.errors  ( -- )
  VERBOSE @
  IF blue-text ." #ERRORS: " normal-text #errors @ . THEN ;

:noname  ( c-addr u -- )
(
Display an error message followed by the line that had the error. 
DST-ERROR-DEFAULT empties neither the string nor the string frame stack.
)
  red-text 1 #errors +! DST-ERROR-DEFAULT normal-text ;
DST-ERROR-XT !

\ before first displayed line
PFE-HOST IFORTH-HOST or [IF] ?.cr [THEN]

PFE-HOST [IF]
  ?." Host is pfe
[THEN]
GFORTH-HOST [IF]
  ?." Host is gforth
[THEN]
IFORTH-HOST [IF]
  ?." Host is iForth
[THEN]

USE-DSTRINGS-EXT [IF]
  ?." Testing with DSTRINGS-EXT module 
[ELSE]
  ?." Testing with dstrings.fs
[THEN]

$" 0" $CONSTANT 0$   $" 10" $CONSTANT 10$
$" 1" $CONSTANT 1$   $" 11" $CONSTANT 11$
$" 2" $CONSTANT 2$   $" 12" $CONSTANT 12$
$" 3" $CONSTANT 3$   $" 13" $CONSTANT 13$
$" 4" $CONSTANT 4$   $" 14" $CONSTANT 14$

[UNDEFINED]  $drops [IF]
: $drops  ( n -- ) ($: n$ ... 1$ -- )  0 ?DO $drop LOOP ;
[THEN]
[UNDEFINED] $= [IF]
: $=      ($: a$ b$ -- ) ( -- flag )   $s> $s> compare 0= ;  \ wff
[THEN]

: empty-$s  ($: n$ ... 1$ -- )  $depth $drops ;

T{ $depth empty-$s       $depth -> 0 0 }T
T{ 1$ $depth empty-$s    $depth -> 1 0 }T
T{ 1$ 2$ $depth empty-$s $depth -> 2 0 }T

TESTING  $DROPS $= 0DST-A

\ $=

T{ 1$ empty$   $= $depth -> false 0 }T
T{ 1$ $" h"    $= $depth -> false 0 }T
T{ 1$ $" he"   $= $depth -> false 0 }T
T{ $" " empty$ $= $depth -> true 0 }T
T{ 1$ $" 1"    $= $depth -> true 0 }T

\ $drops

T{ $depth empty$ empty-$s $depth -> 0 0  }T
T{ 1$ 2$ 3$ 3 $drops $depth -> 0 }T
T{ 1$ 2$ 3$ 2 $drops $depth -> 1 }T
T{ $drop $depth -> 0 }T

\ 0DST-A

CREATE max-3$A 1 , 2 , 3 , 4 ,

T{ max-3$A @ -> 1 }T
T{ 0 max-3$A 0DST-A
     max-3$A @
     max-3$A cell+ @ -> 0 2 }T
T{ 1 max-3$A 0DST-A
     max-3$A @
     max-3$A cell+ @
     max-3$A 2 cells + @ -> 0 0 3 }T
T{ 2 max-3$A 0DST-A
     max-3$A @
     max-3$A cell+ @
     max-3$A 2 cells + @
     max-3$A 3 cells + @ -> 0 0 0 4 }T
T{ 3 max-3$A 0DST-A
     max-3$A @
     max-3$A cell+ @
     max-3$A 2 cells + @
     max-3$A 3 cells + @ -> 0 0 0 0 }T
\ max-3$A is now initialized for GC

TESTING  DST-A! DST-A@ DST-A= 

\ DST-A!

\ set up array overwrite test
3 2 1 3 max-3$A XT-A!

T{ $depth dup max-3$A DST-A!
   max-3$A @
   max-3$A cell+ @ $depth -> 0 0 1 0 }T
T{ 10$ 1 max-3$A DST-A!
   max-3$A @
   max-3$A cell+ $@ 10$ $=
   max-3$A 2 cells + @ $depth -> 1 true 2 0 }T
T{ 12$ 11$ 2 max-3$A DST-A!
   max-3$A @
   max-3$A cell+     $@ 11$ $=
   max-3$A 2 cells + $@ 12$ $=
   max-3$A 3 cells + @ $depth -> 2 true true 3 0 }T
T{ 12$ 11$ 13$ 3 max-3$A DST-A!
   max-3$A @
   max-3$A cell+     $@ 13$ $=
   max-3$A 2 cells + $@ 11$ $=
   max-3$A 3 cells + $@ 12$ $= $depth -> 3 true true true 0 }T

: $ARRAY  ( "name" +n -- ) ( $: $[n-1] ... $0 -- )
  CREATE dup here 2>r 1+ cells allot 
  2r@ ( n 'buf) 0DST-A  \ intialize for GC
  2r@ ( n 'buf) !
  here 2r> nip cell+
  ?DO i $! 1 cells +LOOP ;

0             $ARRAY $[]
1 0$          $ARRAY $[0]
1 10$         $ARRAY $[10]
2 11$ 10$     $ARRAY $[10,11]
2  1$ 10$     $ARRAY $[10,1]
2 11$  0$     $ARRAY $[0,11]
2  1$  0$     $ARRAY $[0,1]
3 12$ 11$ 10$ $ARRAY $[10,11,12]
3 12$ 11$  1$ $ARRAY $[1,11,12]
3 12$  1$  1$ $ARRAY $[1,1,12]
3  2$ 11$  1$ $ARRAY $[1,11,2]
3  1$  1$  1$ $ARRAY $[1,1,1]
3  2$  2$  2$ $ARRAY $[2,2,2]
3  1$  2$  2$ $ARRAY $[2,2,1]
3  1$  1$  2$ $ARRAY $[2,1,1]

\ $ARRAY

T{ $[] @ -> 0 }T
T{ $[10] @ $[10] cell+ $@ 10$ $= -> 1 true }T
T{ $[10,11] @
   $[10,11] cell+ $@ 10$ $=
   $[10,11] 2 cells + $@ 11$ $= -> 2 true true }T

\ DST-A@

T{ $[]         DST-A@ $depth                      -> 0 0 }T
T{ $[10]       DST-A@ 10$ $= $depth               -> 1 true 0 }T
T{ $[10,11]    DST-A@ 10$ $= 11$ $= $depth        -> 2 true true 0 }T
T{ $[10,11,12] DST-A@ 10$ $= 11$ $= 12$ $= $depth -> 3 true true true 0 }T

\ DST-AA= Returns
\        0 true:  equal size and elements
\       0 false:  sizes unequal
\ index+1 false:  sizes equal, deepest unequal elements at index

\ different length
T{ $[]    $[10,11,12] DST-AA= -> 0 false }T
T{ $[10]  $[10,1]     DST-AA= -> 0 false }T
T{ $[10]  $[10,11,12] DST-AA= -> 0 false }T

\ last different at index 0
T{ $[0]        $[10]      DST-AA= -> 1 false }T
T{ $[10,1]     $[0,1]     DST-AA= -> 1 false }T
T{ $[10,11,12] $[1,11,12] DST-AA= -> 1 false }T

\ last different at index 1
T{ $[10,1]     $[10,11]   DST-AA= -> 2 false }T
T{ $[10,1]     $[0,11]    DST-AA= -> 2 false }T
T{ $[1,1,12]   $[1,11,12] DST-AA= -> 2 false }T
T{ $[10,11,12] $[1,1,12]  DST-AA= -> 2 false }T

\ last different at index 2
T{ $[1,11,12] $[1,11,2] DST-AA= -> 3 false }T
T{ $[1,1,12]  $[1,11,2] DST-AA= -> 3 false }T

\ the same
T{ $[]         $[]         DST-AA= -> 0 true }T
T{ $[10]       $[10]       DST-AA= -> 0 true }T
T{ $[10,11,12] $[10,11,12] DST-AA= -> 0 true }T
T{ $[]         DST-A@ max-3$A DST-A! $[]   max-3$A       DST-AA= -> 0 true }T
T{ $[10]       DST-A@ max-3$A DST-A! $[10] max-3$A       DST-AA= -> 0 true }T
T{ $[10,11,12] DST-A@ max-3$A DST-A! $[10,11,12] max-3$A DST-AA= -> 0 true }T

TESTING  EMPTY-$FS DSFT-A! DSFT-AA=

\ empty-$fs

T{           $frame-depth -> 0 }T
T{ empty-$fs $frame-depth -> 0 }T
T{ 0 $frame  $frame-depth -> 1 }T
T{ empty-$fs $frame-depth -> 0 }T
T{ 0 $frame  $frame-depth -> 1 }T

\ DSFT-A!

\ set up array overwrite test, 1-cell count, 3, 2-cell elements
CREATE max-3$FA 1 , 2 , 3 , 4 , 5 , 6 , 7 ,

empty-$fs
T{ $frame-depth max-3$FA DST-A!
   max-3$FA @
   max-3$FA cell+ 2@ $frame-depth $depth
  ->  0 3 2 0 0 }T
T{ 0 $frame $frame-depth max-3$FA DSFT-A!
   max-3$FA @
   max-3$FA cell+ 2@ 
   max-3$FA 3 cells + 2@ $frame-depth $depth
   -> 1 0 $sp@ 5 4 0 0 }T
T{ 0 $frame 10$ 1 $frame $frame-depth max-3$FA DSFT-A!
   max-3$FA @
   max-3$FA cell+ 2@ 
   max-3$FA 3 cells + 2@
   max-3$FA 5 cells + 2@ $frame-depth $depth
   -> 2 1 $sp@ 0 $sp@ cell+ 7 6 0 1 }T
T{ 0 $frame 11$ 1 $frame 12$ 13$ 2 $frame $frame-depth max-3$FA DSFT-A!
   max-3$FA @
   max-3$FA cell+ 2@ 
   max-3$FA 3 cells + 2@
   max-3$FA 5 cells + 2@ $frame-depth $depth
   -> 3 2 $sp@ 1 $sp@ 2 cells + 0 $sp@ 3 cells + 0 4 }T
empty-$s

\ DSFT-AA=

CREATE []                0 ,
CREATE [0,10]            1 ,  0 , 10 ,
CREATE [10,0]            1 , 10 ,  0 ,
CREATE [10,0;11,1]       2 , 10 ,  0 , 11 ,  1 ,
CREATE [10,0;1,11]       2 , 10 ,  0 ,  1 , 11 ,
CREATE [0,10;11,1]       2 ,  0 , 10 , 11 ,  1 ,
CREATE [0,10;1,11]       2 ,  0 ,  10 , 1 , 11 ,
CREATE [10,0;11,1;12,2]  3 , 10 ,  0 , 11 ,  1 , 12 ,  2 ,
CREATE [1,11;11,1;12,2]  3 ,  1 , 11 , 11 ,  1 , 12 ,  2 ,
CREATE [1,11;1,11;12,2]  3 ,  1 , 11 ,  1 , 11 , 12 ,  2 ,
CREATE [1,11;11,1;2,12]  3 ,  1 , 11 , 11 ,  1 ,  2 , 12 ,

\ DSFT-AA=  Returns
\         0 true:  equal size and elements
\        0 false:  sizes unequal
\  index+1 false:  sizes equal, deepest unequal elements at index
empty-$fs

\ different length
T{ []    [10,0;11,1;12,2]   DSFT-AA= -> 0 false }T
T{ [10,0]  [10,0;1,11]      DSFT-AA= -> 0 false }T
T{ [10,0]  [10,0;11,1;12,2] DSFT-AA= -> 0 false }T

\ last different at index 0
T{ [0,10]           [10,0]           DSFT-AA= -> 1 false }T
T{ [10,0;1,11]      [0,10;1,11]      DSFT-AA= -> 1 false }T
T{ [10,0;11,1;12,2] [1,11;11,1;12,2] DSFT-AA= -> 1 false }T

\ last different at index 1
T{ [10,0;1,11]      [10,0;11,1]      DSFT-AA= -> 2 false }T
T{ [10,0;1,11]      [0,10;11,1]      DSFT-AA= -> 2 false }T
T{ [1,11;1,11;12,2] [1,11;11,1;12,2] DSFT-AA= -> 2 false }T
T{ [10,0;11,1;12,2] [1,11;1,11;12,2] DSFT-AA= -> 2 false }T

\ last different at index 2
T{ [1,11;11,1;12,2] [1,11;11,1;2,12] DSFT-AA= -> 3 false }T
T{ [1,11;1,11;12,2] [1,11;11,1;2,12] DSFT-AA= -> 3 false }T

\ the same
T{ []               []               DSFT-AA= -> 0 true }T
T{ [10,0]           [10,0]           DSFT-AA= -> 0 true }T
T{ [10,0;11,1;12,2] [10,0;11,1;12,2] DSFT-AA= -> 0 true }T

TESTING  ${ $-> }$

empty-$fs  empty-$s

\ simple comparisons
${ $-> }$
${ 1$ $-> 1$ }$

${ 1$ 2$ 2 $frame 3$ 1$ 1 $frame $-> 1$ 2$ 2 $frame 3$ 1$ 1 $frame }$

\ initial $stack preservation at MAX-DST-INITIALS
T{ $depth -> 0 }T
${ 3$ $-> 3$ }$
T{ $depth -> 0 }T
1$ 2$ ${ 3$ $-> 3$ }$
T{ 2$ $= 1$ $= $depth -> true true 0 }T

TESTING exceptions
\ Uncomment the appropriate line to see the exception display.

\ $finitials present
${ $-> }$
\ 1$ 2$ 1 $frame ${
1$ 2$ 1 $frame T{ ' ${ CATCH -> -2 }T
empty-$s empty-$fs  

\ $initials overflow
MAX-DST-INITIALS
1 to MAX-DST-INITIALS
1$ ${ $-> }$
empty-$s
\ 1$ 2$ ${
1$ 2$ T{ ' ${ CATCH -> -2 }T
empty-$s
to MAX-DST-INITIALS

\ $results overflow
MAX-DST-RESULTS
1 to MAX-DST-RESULTS
${ 1$ $-> 1$ }$
\ 1$ 2$ $->
1$ 2$ T{ ' $-> CATCH -> -2 }T
empty-$s
to MAX-DST-RESULTS

\ $fresults overflow
MAX-DSFT-RESULTS
1 to MAX-DSFT-RESULTS
${ 0 $frame $-> 0 $frame }$ 
\ 0 $frame 1$ 1 $frame $->
0 $frame 1$ 1 $frame T{ ' $-> CATCH -> -2 }T
empty-$fs empty-$s
to MAX-DSFT-RESULTS

\ $goals overflow
MAX-DST-RESULTS
1 to MAX-DST-RESULTS
\ 1$ 2$  }$
1$ 2$ T{ ' }$ CATCH -> -2 }T
empty-$s
to MAX-DST-RESULTS

\ $fgoals overflow
MAX-DSFT-RESULTS
1 to MAX-DSFT-RESULTS
\ 0 $frame 1$ 1 $frame }$
0 $frame 1$ 1 $frame T{ ' }$ CATCH -> -2 }T
empty-$fs empty-$s
to MAX-DSFT-RESULTS

TESTING errors

VERBOSE @ [IF]
#errors @
?." Inspect the error lines:
${ 2$ $-> 1$ }$
${ 2$ 3$ $-> 2$ }$
${ 2$ $-> 2$ 3$ }$
${ 1$ 2$ 2 $frame 3$ 1$ 1 $frame $-> 1$ 2$ 1 $frame 3$ 1$ 2 $frame }$
${ 1$ 2$ 2 $frame 3$ 1$ 1 $frame $-> 1$ 2$ 3$ 1$ }$
${ 1$ 2$ 3$ 1$ $-> 1$ 2$ 2 $frame 3$ 1$ }$
#errors !
[THEN]

TESTING combinations:  ={ => }=

#4 to MAX-DST-RESULTS  \ has to be < initial #16

: ={  ${ T{ ;   : =>  $-> -> ;   : }=  }$ }T ;

\ simple comparisons
={ => }=
={ 1$ 1e 1 => 1$ 1e 1 }=
={ 1$ 2$ 2 $frame 3$ 1$ 1 $frame => 1$ 2$ 2 $frame 3$ 1$ 1 $frame }=

\ initial $stack preservation at MAX-DST-INITIALS
1$ 2$ ={ 3$ 2e 2 => 3$ 2e 2 }=
T{ 2$ $= 1$ $= $depth -> true true 0 }T

TESTING errors

VERBOSE @ [IF]
#errors @
?." Inspect the error lines:
={ 2$ 5e => 1$ }=
={ 1$ 1e 2 => 1$ 1e 1 }=
={ 2$ 3$ 6e 1 => 2$ 4e 2 }=
={ 2$ 1e 1 => 2$ 3$ 1e 1 }=
={ 1$ 2$ 2 $frame 3$ 1$ 1 $frame => 1$ 2$ 1 $frame 3$ 1$ 2 $frame }=
={ 1$ 2$ 2 $frame 3$ 1$ 1 $frame => 1$ 2$ 3$ 1$ }=
={ 1$ 2$ 3$ 1$ => 1$ 2$ 2 $frame 3$ 1$ }=
#errors !
[THEN]

\ keep bl at end of next line
?." Unexpected " ?.errors GFORTH-HOST [IF] ?.cr [THEN]
